# BPW40_Photometer.py
# -*- coding: utf-8 -*-

from Tkinter import *
import spidev 
import time

# SPI setup
spi_max_speed = 1000000     # 1 MHz for SPI
CE = 0                      # select SPI 

spi = spidev.SpiDev()
spi.open(0,CE)              

root=Tk()
root.font=('Arial', 30, 'normal')
root.title("Luxmeter") 
root.geometry('280x60') #window size


def read_mcp3002(lb):
    cmd = 0b01100000  # CH0
    #   cmd = 0b01110000   # CH1
    Voltage = 0
    for i in range(4):
        spi_data = spi.xfer2([cmd,0]) # start SPI communication
        adc_data = ((spi_data[0] & 3) << 8) + spi_data[1]
        Voltage = adc_data + Voltage
        time.sleep(0.1)
    Voltage = int(Voltage / 4 /1.023)/10.0
    lb.config(text= "I = " + str(Voltage) + " %")
    lb.after(100, read_mcp3002, lb)
    # return adc_data

lb = Label(root)
lb.config(text="", font = root.font)
lb.pack()

read_mcp3002(lb)
root.mainloop()

