# CommandCenter.py
# switch LEDs using pushbuttons in Tkinter
# get GPIO-Pin status using INTERRUPT

from Tkinter import *   
import RPi.GPIO as GPIO 

GPIO.setmode(GPIO.BCM)  
GPIO.setup(7,GPIO.OUT) 
GPIO.setup(8,GPIO.IN,pull_up_down=GPIO.PUD_UP)

root=Tk()

ledstate=StringVar()   
ledstate.set("switch undefined") 

def on() :
    GPIO.output(7,1) # GPIO 07 on
    return

def off():
    GPIO.output(7,0) # GPIO 07 off
    return

def state_isr(pin): # subroutine for interrupt
    if GPIO.input(8)==0: 
        ledstate.set("switch closed") 
    else:
        ledstate.set("switch open")
    return

root.title("Command Center")
root.geometry("240x80") # window size

Button(text="LED on ", command=on, bg="green", fg="black").pack()
Button(text="LED off", command=off, bg="red", fg="white").pack()

# check statusGPIO08
Label(root,textvariable=ledstate,bg="blue", fg="white").pack() 		
GPIO.add_event_detect(8, GPIO.BOTH, callback=state_isr) 
root.mainloop()
