# DS1820_temperature_plotter.py
# -*- coding: utf-8 -*-

import os
import matplotlib.pyplot as plt
import sys 
import os

# read 1-Wire slave list
file = open('/sys/devices/w1_bus_master1/w1_master_slaves') 
w1_slaves = file.readlines() 
file.close()
tempC = []
plt.ion()

def plotNow():
    plt.clf()
    plt.ylim(20, 30)
    plt.title('Local temperature')
    plt.grid(True)
    plt.ylabel('Temp in C')
    plt.plot(tempC)
    plt.show()

# pre-load initial data
for i in range(0,51):
    tempC.append(0)
    
while True:
    for line in w1_slaves: 

        # extract 1-wire slave
        w1_slave = line.split("\n")[0] 

        # read corresponding file
        file = open('/sys/bus/w1/devices/' + str(w1_slave) + '/w1_slave')
        filecontent = file.read() 
        file.close() 
        
        # read and convert temperature
        stringvalue = filecontent.split("\n")[1].split(" ")[9] 
        temperature = float(stringvalue[2:]) / 1000 

    temp = temperature
    tempC.append(temp)
    tempC.pop(0)
    plotNow()
    plt.pause(.1)
