# DS1820_tempread_graphic.py
# -*- coding: utf-8 -*- 

import sys 
import os
from Tkinter import *
import time

# read 1-Wire slave list
file = open('/sys/devices/w1_bus_master1/w1_master_slaves') 
w1_slaves = file.readlines() 
file.close()

root=Tk()

root.font=('Arial', 30, 'normal')
root.title("DS1820 Temp") 
root.geometry('250x60') #window size

def getTempValue(lb):
    for line in w1_slaves: 
        # extract 1-wire slave
        w1_slave = line.split("\n")[0] 
        # read corresponding file
        file = open('/sys/bus/w1/devices/' + str(w1_slave) + '/w1_slave')
        filecontent = file.read() 
        file.close() 
        # read and convert temperature
        stringvalue = filecontent.split("\n")[1].split(" ")[9] 
        temperature = float(stringvalue[2:]) / 1000 
        lb.config(text="T = " + '  %4.1f °C' % temperature)
        time.sleep(.1)
        lb.after(100, getTempValue , lb)
        
lb = Label(root)

lb.config(text="T = 0 °C", font = root.font)
lb.pack()

getTempValue(lb)
root.mainloop() 



