# DS1820_w_display.py

import RPi.GPIO as GPIO
import time
GPIO.setmode(GPIO.BCM)

# GPIO ports for display pins
#            a  b  c  d e  f  g  DP
segments =  (18,14,25,9,11,15,24,10)

for segment in segments:
    GPIO.setup(segment, GPIO.OUT)
    GPIO.output(segment, 1)


# GPIO ports for digits pins 
#         Th  H  T  O
digits = (22, 7, 8, 23)


for digit in digits:
    GPIO.setup(digit, GPIO.OUT)
    GPIO.output(digit, 0)

num ={  ' ':(1,1,1,1,1,1,1),    '0':(0,0,0,0,0,0,1),
        '1':(1,0,0,1,1,1,1),    '2':(0,0,1,0,0,1,0),
        '3':(0,0,0,0,1,1,0),    '4':(1,0,0,1,1,0,0),
        '5':(0,1,0,0,1,0,0),    '6':(0,1,0,0,0,0,0),
        '7':(0,0,0,1,1,1,1),    '8':(0,0,0,0,0,0,0),
        '9':(0,0,0,0,1,0,0)}

# read 1-Wire slave list
file = open('/sys/devices/w1_bus_master1/w1_master_slaves') 
w1_slaves = file.readlines() 
file.close()

try:
    while True:
        #read DS1820
        for line in w1_slaves: 
            # extract 1-wire slave
            w1_slave = line.split("\n")[0] 
            # read corresponding file
            file = open('/sys/bus/w1/devices/' + str(w1_slave) + '/w1_slave')
            filecontent = file.read() 
            file.close() 
            # read and convert temperature
            stringvalue = filecontent.split("\n")[1].split(" ")[9] 
            temperature = int(stringvalue[2:])
        # show rtesult in LED display
        s = str(temperature)
        if temperature < 10000: s = "0" + s
        for i in range (1, 300):
            for digit in range(4):
                for loop in range(0,7):
                    GPIO.output(segments[loop], num[s[digit]][loop])
                    if (digit == 1):
                      GPIO.output(10, 0)
                    else:
                        GPIO.output(10, 1)
                GPIO.output(digits[digit], 1)
                time.sleep(0.001)
                GPIO.output(digits[digit], 0)
finally:
    GPIO.cleanup()
