# demo_histogram.py
import numpy as np
import matplotlib.mlab as mlab
import matplotlib.pyplot as plt

# generation of example data
mu = 30  # mean of distribution
sigma = 5  # standard deviation of distribution
x = mu + sigma * np.random.randn(10000)
num_bins = 30

# the histogram of the data
n, bins, patches = plt.hist(x, num_bins, normed=1, facecolor='blue', alpha=0.5)

# add a 'best fit' line
y = mlab.normpdf(bins, mu, sigma)
plt.plot(bins, y, 'g')
plt.xlabel('Counts')
plt.ylabel('Probability')
plt.title(r'Histogram example')

# Tweak spacing to prevent clipping of ylabel
plt.subplots_adjust(left=0.15)
plt.show()
