# MCP3002_ADC.py

import spidev 
from time import sleep

# SPI setup
spi_max_speed = 1000000     # 1 MHz for SPI
CE = 0                      # select SPI device

spi = spidev.SpiDev()
spi.open(0,CE)              


def read_mcp3002():
    cmd = 0b01100000 # CH0
    # cmd = 0b01110000 for CH1
    spi_data = spi.xfer2([cmd,0]) # start communication
    adc_data = ((spi_data[0] & 3) << 8) + spi_data[1]
    return adc_data

print("MCP3002")
print("SPI device = {0}".format(CE))
print("=========================\n")

while True:
    CH0_data = read_mcp3002()
    print("CH0 data: {}".format(CH0_data))
    sleep(1)
    


