# Simple_NTC_thermometer.py
# -*- coding: utf-8 -*-
# Pin Config: activePort-NTC4k7-readoutPort-10uF-GND

from Tkinter import *
import RPi.GPIO as GPIO
import time

GPIO.setwarnings(False) 
GPIO.setmode(GPIO.BCM)

activePort = 8
readoutPort = 7
cal = 1000.0
offset = 90.0

GPIO.setup(activePort, GPIO.OUT)
GPIO.setup(readoutPort, GPIO.IN)   

root=Tk()

root.font=('Arial', 30, 'normal')
root.title("Thermometer") 
root.geometry('250x60') #window size

def getTempValue(lb):
    GPIO.output(activePort, 1)
    time.sleep(1)
    GPIO.output(activePort, 0)
    tStart = time.time()
    while GPIO.input(readoutPort) > 0:
       pass
    tStop = time.time()
    T = int (offset-((tStop-tStart)*cal))
    lb.config(text="T = " + str(T) + " °C")
    time.sleep(1)
    lb.after(100, getTempValue , lb)

lb = Label(root)

lb.config(text="", font = root.font)
lb.pack()

getTempValue(lb)
root.mainloop() 
