# hygrometer.py

from Tkinter import *
import RPi.GPIO as GPIO
import time

activePort = 25

GPIO.setmode(GPIO.BCM)
GPIO.setup(activePort, GPIO.IN)

NUM_CYCLES = 100
cal = 100

root=Tk()
root.font=('Arial', 30, 'normal')
root.title("Hygrometer") 
root.geometry('420x60') #window size

def getTempValue(lb):
    tStart = time.time()
    for impulse_count in range(NUM_CYCLES):
        GPIO.wait_for_edge(activePort, GPIO.FALLING)
    tStop = time.time()
    f = (int(cal/(tStop-tStart)))/10.0
    lb.config(text="Rel. Feuchte: " + str(f) + " %")
    time.sleep(1)
    lb.after(100, getTempValue , lb)

lb = Label(root)

lb.config(text="", font = root.font)
lb.pack()

getTempValue(lb)
root.mainloop() 
