#!/usr/bin/python
import RPi.GPIO as GPIO
from pykeyboard import PyKeyboard
import time

GPIO.setmode(GPIO.BCM)

K1 = 21
K2 = 20
K3 = 10
K4 = 24
K5 = 7
K6 = 12
L1 = 18

gpio_in = [K1, K2, K3, K4, K5, K6]
gpio_old = {K1:0, K2:0, K3:0, K4:0, K5:0, K6:0}

k = PyKeyboard()
pause = 0.01

for gpio in gpio_in:
  GPIO.setup(gpio, GPIO.IN)

GPIO.setup(L1, GPIO.OUT, initial=0)

while True:
  time.sleep(pause)

  if GPIO.input(K1) == 0 and gpio_old[K1] == 1:
    k.press_key(k.enter_key)
    gpio_old[K1] = 0
  elif GPIO.input(K1) == 1 and gpio_old[K1] == 0:
    k.release_key(k.enter_key)
    gpio_old[K1] = 1

  if GPIO.input(K2) == 0 and gpio_old[K2] == 1:
    k.press_key(' ')
    gpio_old[K2] = 0
  elif GPIO.input(K2) == 1 and gpio_old[K2] == 0:
    k.release_key(' ')
    gpio_old[K2] = 1

  if GPIO.input(K3) == 0 and gpio_old[K3] == 1:
    k.press_key(k.down_key)
    gpio_old[K3] = 0
  elif GPIO.input(K3) == 1 and gpio_old[K3] == 0:
    k.release_key(k.down_key)
    gpio_old[K3] = 1 

  if GPIO.input(K4) == 0 and gpio_old[K4] == 1:
    k.press_key(k.right_key)
    gpio_old[K4] = 0
  elif GPIO.input(K4) == 1 and gpio_old[K4] == 0:
    k.release_key(k.right_key)
    gpio_old[K4] = 1

  if GPIO.input(K5) == 0 and gpio_old[K5] == 1:
    k.press_key(k.left_key)
    gpio_old[K5] = 0 
  elif GPIO.input(K5) == 1 and gpio_old[K5] == 0:
    k.release_key(k.left_key)
    gpio_old[K5] = 1

  if GPIO.input(K6) == 0 and gpio_old[K6] == 1:
    k.press_key(k.escape_key)
    gpio_old[K6] = 0
  elif GPIO.input(K6) == 1 and gpio_old[K6] == 0:
    k.release_key(k.escape_key)
    gpio_old[K6] = 1

  LED = 0
  for gpio in gpio_in:
    LED = LED or (not GPIO.input(gpio))
  GPIO.output(L1, LED)
